#include "../../../lib/std.mi"

#define ROTATION_LAYER_VAR MyVar
#include "../../../lib/rotationlayer.m"

//make a second rotationlayer.m called rotationlayer2.m
//and replace all ROTATION_LAYER_VAR with ROTATION_LAYER_VAR_B
#define ROTATION_LAYER_VAR_B MyVar2
#include "../../../lib/rotationlayer2.m"


Function setVolumeLayer(int val);
Function setSVolumeLayer(int val);

Global Layout MN, MS;
Global Group MainScreen, MenuScreen, ThingScreen, EQScreen, ShadeDraw;
Global Button STMenu, STThing, STEQ, SBFMenu, ShDrButton;
Global AnimatedLayer IntroAnim, VisAnim;
Global Layer Volume_L, AnimVis_L, SVolume_L, LM1, LM2;
Global Map VolMap, SVolMap;
Global Boolean VolClick, IOO, SVolClick;
Global Timer visUpdate;
Global Int VisInt, LastClickEd=0;
Global Vis TehVisor;

System.onScriptLoaded() {
  MN = getContainer("main").getLayout("normal");
  MS = getContainer("main").getLayout("shade");

  MainScreen = MN.getObject("group.main");
  MenuScreen = MN.getObject("group.menu");
  ThingScreen = MN.getObject("group.thinger");
  EQScreen = MN.getObject("group.eq");

  STMenu = MN.getObject("Menu Press");
  STThing = MN.getObject("TH Press");
  STEQ = MN.getObject("EQ Press");
  SBFMenu = MenuScreen.getObject("Exit MM Norm");

  IntroAnim = MN.getObject("into.anim");

  Volume_L = MN.getObject("Volume Full");

  VolMap = new map;
  VolMap.loadMap("player.vol.map");

  _MyVarInit(MN, "Volume Knob");
  _MyVar2Init(MS, "Volume Knob");

  setVolumeLayer(getVolume());

  AnimVis_L = MainScreen.getObject("teh.anim.click");
  VisAnim = MainScreen.getObject("teh.anim.vis");
  TehVisor = MainScreen.getObject("teh.uber.vis");
  visUpdate = new timer;
  visUpdate.setDelay(99);

  VisInt = 0;

  VisAnim.hide();
  TehVisor.show();
  TehVisor.setMode(0);

  if(getStatus() == 1) visUpdate.start();

  ShadeDraw = MS.getObject("shade.draw.group");
  ShDrButton = ShadeDraw.getObject("move");
  IOO = false;

  SVolMap = new map;
  SVolMap.loadmap("shade.volume.map");
  SVolume_L = MS.getObject("Volume Full");
  
  LM1 = MainScreen.getObject("layer.main.1");
  LM2 = MainScreen.getObject("layer.main.2");

  LM1.hide();
  LM2.hide();
}

STMenu.onLeftButtonUp(int x, int y) {
  if(LastClickEd == 1) {
    MainScreen.show();
    ThingScreen.hide();
    EQScreen.hide();
    MenuScreen.hide();
    LastClickEd = 0;
  } else {
    MainScreen.hide();
    ThingScreen.hide();
    EQScreen.hide();
    MenuScreen.show();
    LastClickEd = 1;
  }
}

STThing.onLeftButtonUp(int x, int y) {
  if(LastClickEd == 2) {
    MainScreen.show();
    ThingScreen.hide();
    EQScreen.hide();
    MenuScreen.hide();
    LastClickEd = 0;
  } else {
    MainScreen.hide();
    ThingScreen.show();
    EQScreen.hide();
    MenuScreen.hide();
    LastClickEd = 2;
  }
}

STEQ.onLeftButtonUp(int x, int y) {
  if(LastClickEd == 3) {
    MainScreen.show();
    ThingScreen.hide();
    EQScreen.hide();
    MenuScreen.hide();
    LastClickEd = 0;
  } else {
    MainScreen.hide();
    ThingScreen.hide();
    EQScreen.show();
    MenuScreen.hide();
    LastClickEd = 3;
  }
}

SBFMenu.onLeftButtonUp(int x, int y) {
  MainScreen.show();
  ThingScreen.hide();
  EQScreen.hide();
  MenuScreen.hide();
}

IntroAnim.onFrame(Int framenum) {
  if(framenum == IntroAnim.getEndFrame()) {
     IntroAnim.setTargetA(0);
     IntroAnim.setTargetSpeed(1);
     IntroAnim.gotoTarget();
  }
}

Volume_L.onMouseMove(int x, int y) {
  if(VolClick) {
    String tx = Volume_L.getXmlParam("x");
    String ty = Volume_L.getXmlParam("y");
    int l_zx;
    l_zx = StringToInteger(tx);
    int l_zy;
    l_zy = StringToInteger(ty);

    int r_zx = x - l_zx;
    int r_zy = y - l_zy;

    int volval = VolMap.getValue(r_zx ,r_zy);
    setVolume(volval);
  }
}

Volume_L.onLeftButtonDown(int x, int y) {
  VolClick = true;
    String tx = Volume_L.getXmlParam("x");
    String ty = Volume_L.getXmlParam("y");
    int l_zx;
    l_zx = StringToInteger(tx);
    int l_zy;
    l_zy = StringToInteger(ty);

    int r_zx = x - l_zx;
    int r_zy = y - l_zy;

    int volval = VolMap.getValue(r_zx ,r_zy);
    setVolume(volval);
}

Volume_L.onLeftButtonUp(int x, int y) {
  VolClick = false;
}

System.onVolumeChanged(int value) {
  setVolumeLayer(value);
  setSVolumeLayer(value);
}

setVolumeLayer(int val) {
  Volume_L.setRegionFromMap(VolMap, val, 1);

  double tempval;
  tempval = 360/255;
  double degval; 
  degval = 360-(val*tempval);
  _MyVarRotateDegree(degval);
}

SVolume_L.onLeftButtonUp(int x, int y) {
  SVolClick = false;
}

SVolume_L.onLeftButtonDown(int x, int y) {
  SVolClick = true;
  String tx = SVolume_L.getXmlParam("x");
  String ty = SVolume_L.getXmlParam("y");
  int l_zx;
  l_zx = StringToInteger(tx);
  int l_zy;
  l_zy = StringToInteger(ty);
  int r_zx = x - l_zx;
  int r_zy = y - l_zy;
  int volval = SVolMap.getValue(r_zx ,r_zy);
  setVolume(volval);
}

SVolume_L.onMouseMove(int x, int y) {
  if(SVolClick) {
    String tx = SVolume_L.getXmlParam("x");
    String ty = SVolume_L.getXmlParam("y");
    int l_zx;
    l_zx = StringToInteger(tx);
    int l_zy;
    l_zy = StringToInteger(ty);
    int r_zx = x - l_zx;
    int r_zy = y - l_zy;
    int volval = SVolMap.getValue(r_zx ,r_zy);
    setVolume(volval);
  }
}

setSVolumeLayer(int val) {
  SVolume_L.setRegionFromMap(SVolMap, val, 1);

  double tempval;
  tempval = 360/255;
  double degval; 
  degval = 360-(val*tempval);
  _MyVar2RotateDegree(degval);
}


visUpdate.onTimer() {
  int v_l = getLeftVuMeter();
  int v_r = getRightVuMeter();
  int v_t = ((v_l + v_r)/2)/14.1666667;
  VisAnim.gotoFrame(v_t);
}

System.onPlay() {
  visUpdate.start();
}

System.onStop() {
  visUpdate.stop();
  VisAnim.gotoFrame(0);
}

System.onPause() {
  visUpdate.stop();
}

System.onResume() {
  visUpdate.start();
}

AnimVis_L.onLeftButtonUp(int x, int y) {
  VisInt += 1;
  if(VisInt > 6) VisInt = 0;

  if(VisInt == 0) {
    VisAnim.hide();
    TehVisor.show();
    TehVisor.setMode(0);
    LM1.hide();
    LM2.hide();
  } else if(VisInt == 5) {
    VisAnim.hide();
    TehVisor.show();
    TehVisor.setMode(1);
    LM1.show();
    LM2.show();
  } else if(VisInt == 6) {
    VisAnim.hide();
    TehVisor.show();
    TehVisor.setMode(2);
    LM1.show();
    LM2.show();
  } else if(VisInt == 1) {
    VisAnim.setXMLParam("image","player.vis.1");
    VisAnim.show();
    TehVisor.hide();
    TehVisor.setMode(0);
    LM1.hide();
    LM2.hide();
  } else if(VisInt == 2) {
    VisAnim.setXMLParam("image","player.vis.2");
    VisAnim.show();
    TehVisor.hide();
    TehVisor.setMode(0);
    LM1.hide();
    LM2.hide();
  } else if(VisInt == 3) {
    VisAnim.setXMLParam("image","player.vis.3");
    VisAnim.show();
    TehVisor.hide();
    TehVisor.setMode(0);
    LM1.hide();
    LM2.hide();
  } else if(VisInt == 4) {
    VisAnim.setXMLParam("image","player.vis.4");
    VisAnim.show();
    TehVisor.hide();
    TehVisor.setMode(0);
    LM1.hide();
    LM2.hide();
  }
}

ShDrButton.onLeftButtonUp(int x, int y) {
  if(IOO == true) {
    IOO = false;
    ShadeDraw.setTargetX(84);
  } else {
    IOO = true;
    ShadeDraw.setTargetX(10);
  }
  ShadeDraw.setTargetSpeed(1);
  ShadeDraw.gotoTarget();
}